###############################
# package CAS::cas2
#
# $Id: cas2.pm,v 1.11 2005-12-05 16:10:40+09 naito Exp $
#$############# 
# 
# nu-CAS client module:
# %result = &site_local::CAS::cas2::cas_client(\%ENV, \%CAS, \%form) ;
# ڼ %ENV, %CAS, %form
# ڸƤӽФ
#  %CAS = (
#  	"SERVER" => "www.math.nagoya-u.ac.jp/cas/", 
#  	"LOGIN_SSL" => 1, 
#  	"VALIDATE_SSL" => 1, 
#  	"GOBACK_SSL" => 1, 
#  	"CLIENT_PROTOCOL" => "https", 
#  	); 
#    ---------------------------------------
#    $CAS{"SERVER_NAME"}: Server Name (eg. www.math.nagoya-u.ac.jp/cas/)
#    $CAS{"LOGIN_SSL"}:    1 => use SSL for login,    0 => NOT use SSL for login.
#    $CAS{"VALIDATE_SSL"}: 1 => use SSL for validate, 0 => NOT use SSL for validate.
#    $CAS{"GOBACK_SSL"}:   1 => use SSL for go back,  0 => NOT use SSL for goback.
#    $CAS{"PORT"}:         Port Numher for CAS Server. If undefined then use 80 (non-SSL cas) or 443 (SSL-case).
#    ---------------------------------------
#  $form{"CASREQUESTMETHOD"} = "POST" ; 
#  or
#  $form{"CASREQUESTMETHOD"} = "GET" ;
#    ---------------------------------------
#  $form{"ENCODING"} = "EUC-JP" ;
#    ---------------------------------------
# %form ξ
#    1. URL decode Ƥ뤳.
#    2. ƤӽФȤˤϡʸλȡפؤν񤭴ʤƤ.
# ͡
#   $result{"RESULT"}  "SUCCESS" ͤ.
#      % {$result{"attributes"}} ˤ°ͤͤäƤ.
#      °ͤͤ "ENCODING" ˤä encode Ƥ.
#      ʤʤ, module ǥɤѴƤ
#%#############

package CAS::cas2 ;
use LWP::UserAgent ;
use LWP::Simple ;

######## Servlet Names
$LOGIN_URI="login";
$CHECK_URI="serviceValidate";
$LOGOUT_URI="logout";
$GOBACK_URI="backService.jsp" ;

#$#######
# CAS client μ¹
# *ENV: Ķʤ HASH
# *CAS: CAS Server ʤɤξޤ HASH
# *form: URLdecode  form parameter ʤ HASH
#########
sub cas_client
{
    local(*ENV, *CAS, *form) = @_ ;
    my $CAS_LOGIN_URI  = &make_cas_url($CAS{LOGIN_SSL},    $CAS{SERVER}, $CAS{PORT}, $LOGIN_URI) ;
    my $CAS_CHECK_URI  = &make_cas_url($CAS{VALIDATE_SSL}, $CAS{SERVER}, $CAS{PORT}, $CHECK_URI) ;
    my $CAS_GOBACK_URI = &make_cas_url($CAS{GOBACK_SSL},   $CAS{SERVER}, $CAS{PORT}, $GOBACK_URI) ;
    ########################
    if (exists $ENV{CONTENT_LENGTH}) {
# 	open OUT, ">>/tmp/cas.result" ;
# 	printf OUT "CONTENT LENGTH = %s\n", $ENV{CONTENT_LENGTH} ;

	read(STDIN, $contents, $ENV{CONTENT_LENGTH}) ;

# 	printf OUT "content = %s\n", $content ;
	$contents =~s/\+/%20/g ;
	@content = split /\&/, $contents ;
	foreach (@content) {
	    local($k, $v) = split /=/, $_, 2 ;
	    $form{$k} = $v ;
	}

# 	close OUT ;

    }
    #####################################################################################
    ## CAS  call ν
    #####################################################################################
    my $ticket = "" ;
    my $parameter = "" ;
    my $ENCODING = "" ;
    my $CASREQUESTMETHOD = "" ;
    foreach my $k (keys %form) {
	if ($k eq "ticket") { $ticket = $form{$k} ; }
	elsif ($k eq "CASREQUESTMETHOD") { $CASREQUESTMETHOD = $form{$k} ; }
	elsif ($k eq "ENCODING") { $ENCODING = $form{$k} ; }
	elsif ($k eq "submit") { } 
	else {
	    $form{$k} =~s/%([A-Fa-f0-9][A-Fa-f0-9])/chr(hex($1))/eg ;
	    $encodeForm{$k} = $form{$k} ;
  	    $encodeForm{$k} =~s/ /%20/g ;
  	    # $encodeForm{$k} =~s/%/%25/g ;
  	    $encodeForm{$k} =~s/&/%26/g ;
  	    $encodeForm{$k} =~s/=/%3D/g ;
  	    $encodeForm{$k} =~s/</%3C/g ;
  	    $encodeForm{$k} =~s/>/%3E/g ;
  	    $encodeForm{$k} =~s/\"/%22/g ;
  	    $encodeForm{$k} =~s/\?/%3F/g ;
  	    $encodeForm{$k} =~s/\n/%0A/g ;
  	    $encodeForm{$k} =~s/\r/%0D/g ;
	}
    }
    ####### SERVICE κ
    my $URL = (split /\?/, $ENV{'REQUEST_URI'})[0]  ;
    my $SERVICE ; 
    if (($ENV{'SERVER_PORT'} eq "443")||($ENV{'SERVER_PORT'} eq "80")) { 
	$SERVICE = $CAS{CLIENT_PROTOCOL} . "://" . $ENV{'HTTP_HOST'} . $URL ; 
    }
    else {
	$SERVICE = $CAS{CLIENT_PROTOCOL} . "://" . $ENV{'HTTP_HOST'} . ":" . $CAS{'SERVER_PORT'} . $URL ; 
    }
    #####################################################################################

    local(%return_hash) ; undef(%return_hash) ;
    #### 1. ticket  null ΤȤ, CAS Server  redirection Ԥ.
    # if (($ticket eq "")||($ticket eq "null")) {
    if ((!exists($form{"ticket"})) 
	|| ($form{"ticket"} eq "null")
	|| ($form{"ticket"} eq "")) {

	&perform_redirection(\%CAS, $CAS_LOGIN_URI, \%encodeForm, "null", $ENCODING, $CASREQUESTMETHOD, $SERVICE) ; 
	return ;
    }
    #### 2. ticket  null ǤϤʤȤ.
    else {
	local($login_url) = sprintf "%s?ticket=%s&service=%s", $CAS_CHECK_URI, $form{"ticket"}, $SERVICE ;

	local($body) ;

	if ($login_url =~/^https:/) {
	    undef $/ ;
	    open URL, "/usr/bin/curl -k \"$login_url\" 2> /dev/null 1| " ;
	    $body = <URL> ;
	    close URL ;
	}
	else {
	    local($http) = LWP::UserAgent->new ;
	    $http->timeout(3) ;
	    local($req) = $http->get($login_url) ;
	    if ($req->is_success) { $body = $req->content ; }
	}

	$return_hash{"BODY"} = $body ;
	$return_hash{'FULL'} = $body ;
	$return_hash{'FULL'} =~s/</&lt;/g ; $return_hash{'FULL'} =~s/>/&gt;/g ;

	if ($form{"ENCODING"} !~/utf-8/i) {
	    use Encode qw/encode decode/;
	    local($encoding) = $form{"ENCODING"} ;
	    $encoding =~tr/A-Z/a-z/;
	  utf8::decode($body) ;
	    $body = encode($encoding, $body) ;
	}

	use XML::simple ;
	my %main_tree = &XML::simple::xml_simple($body) ;
	my %tree = % {$main_tree{"cas:serviceResponse"}} ;

 	if (exists($tree{"cas:authenticationSuccess"})) {
 	    $return_hash{'RESULT'} = "SUCCESS" ;
	    my %sub_hash = % {$tree{"cas:authenticationSuccess"}} ;
 	    foreach my $k (keys %sub_hash) {
 		if (ref($sub_hash{$k}) ne "HASH") {
 		    my $k0 = $k ; $k0 =~s/^cas://g ;
		    $k0 =~tr/A-Z/a-z/;
 		    $return_hash{$k0} = $sub_hash{$k} ;
 		}
 		else {
 		    my %sub_sub_hash = % {$sub_hash{$k}} ;
 		    foreach my $l (keys %sub_sub_hash) {
 			my $l0 = $l ; $l0 =~s/^cas://g ;
			$l0 =~tr/A-Z/a-z/;
 			$ {$return_hash{"attributes"}}{$l0} = $sub_sub_hash{$l} ;
 		    }
 		}
 	    }
 	}
   	else {
 	    $return_hash{'RESULT'} = "FAIL" ;
	    local($code) = $tree{"cas:authenticationFailure"} ;
     	    if ($code eq "INVALID_TICKET") {
		&perform_redirection(\%CAS, $CAS_LOGIN_URI, \%encodeForm, "null", $ENCODING, $CASREQUESTMETHOD, $SERVICE) ; 
 		return ;
     	    }
     	    else {
 		local($login_url) = sprintf "%s?ticket=%s&service=%s", $CAS_CHECK_URI, $ticket, $SERVICE ;
 		&redirect($CAS_GOBACK_URI . "?edu.yale.its.tp.cas.status=" . $code) ;
 		return ;
     	    }
   	}
    }
    ###### , 񤭴 Form Data ᤹.
    foreach my $k (keys %form) {
	local($temp) = $form{$k} ;
	$temp =~s/&/&amp;/g ;
	$temp =~s/</&lt;/g ;
	$temp =~s/>/&gt;/g ;
	$temp =~s/\"/&quot;/g ;
	$form{$k} = $temp ;
    }

    foreach $key (keys %form) {
	local($v) = $form{$key} ;
	$v =~s/%([A-Fa-f0-9][A-Fa-f0-9])/chr(hex($1))/eg ;
	$form{$key} = &sanitary($v) ;
    }

    return %return_hash ;
}


sub get_url_parameter
{
    local(%ENV) = @_ ;
    local($foo, $query_string) = split /\?/, $ENV{"REQUEST_URI"} ;
    my $ticket = "" ;
    local(@request) = split /&/, $query_string ;
    my (@query) ; undef (@query) ;
    foreach (@request) {
	my ($r, $v) = split /=/ ;
	if ($r eq "ticket") { $ticket = $v ; }
	else { push @query, $_ ; }
    }
    my $parameter = "" ;
    if ($#query != -1) {
	$parameter = join "&", @query ;
    }
    return $parameter ;
}

#$###########
#
#
#############
sub perform_redirection
{
    local(*CAS, $CAS_LOGIN_URI, *encodeForm, $ticket, $ENCODING, $CASREQUESTMETHOD, $SERVICE) = @_ ;
    # redirect_by_post($CAS_LOGIN_URI, $SERVICE, \%encodeForm, $ticket, $ENCODING, $form{"CASREQUESTMETHOD"}) ;
    redirect_by_post($CAS_LOGIN_URI, $SERVICE, \%encodeForm, $ticket, $ENCODING, $CASREQUESTMETHOD) ;
}

sub redirect
{
    local($CAS_LOGIN_URI, $SERVICE, *encodeForm) = @_ ;
    local($location) = sprintf "%s?service=%s", $CAS_LOGIN_URI, $SERVICE ;
    local(@param) ; undef (@param) ;
    foreach my $k (sort keys %encodeForm) {
	push @param, sprintf "%s=%s", $k, $encodeForm{$k} ;
    }
    if ($#param != -1) {
	$location .= sprintf "%%3F%s", join "%26", @param ;
    }
    print "Content-Type: text/html\n" ;
    print "\n\n";
    printf "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 2.0//EN\">\n" ;
    printf "<html><head>\n" ;
    printf "<script> window.location.href=\"%s\"; </script>\n", $location ;
    printf "</head>\n" ;
    printf "<body>\n" ;
    printf "<noscript> click <a href=\"%s\">here</a> to access the service you requested.</noscript>\n", $location;
    printf "</body>\n" ;
    printf "</html>\n" ;
    printf "\n\n" ;
}

sub redirect_by_post 
{
    local($casLogin, $service, *encodeForm, $ticket, $encoding, $method) = @_ ;
    my $CAS_POST_STRING = "" ;
    my @p ; undef @p ;
    foreach my $k (sort keys %encodeForm) {
	push @p, sprintf "%s=%s", $k, $encodeForm{$k} ;
    }
    my $t = sprintf "%s?%s", $service, join "&", @p ;
    $CAS_POST_STRING .= "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n" ;
    $CAS_POST_STRING .= "<html>\n<head>\n" ;
    $CAS_POST_STRING .= "<title>Central Authentication Service</title>\n" ;
    $CAS_POST_STRING .= sprintf "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=%s\">\n", $encoding ;
    $CAS_POST_STRING .= "</head>\n" ;
    $CAS_POST_STRING .= "<body bgcolor=\"#ffffff\" link=\"#000000\" alink=\"#000000\" vlink=\"#000000\" onLoad=\"document.form.submit()\">\n" ;
    $CAS_POST_STRING .= "<noscript>Push</noscript>\n" ;
    $CAS_POST_STRING .= sprintf "<form name=\"form\" action=\"%s\" method=POST>\n", $casLogin ;
    $CAS_POST_STRING .= sprintf "<input type=\"hidden\" name=\"ticket\" value=\"%s\">\n", $ticket ;
    $CAS_POST_STRING .= sprintf "<input type=\"hidden\" name=\"service\" value=\"%s\">\n", $t ;
    $CAS_POST_STRING .= sprintf "<input type=\"hidden\" name=\"CASREQUESTMETHOD\" value=\"%s\">\n", $method ;
    $CAS_POST_STRING .= sprintf "<input type=\"hidden\" name=\"ENCODING\" value=\"%s\">\n", $encoding ;
    $CAS_POST_STRING .= "<noscript><input type=\"submit\"></noscript>\n" ;
    $CAS_POST_STRING .= "</form>\n" ;
    $CAS_POST_STRING .= "<noscript>to access the service you requested.</noscript>\n" ;
    $CAS_POST_STRING .= "</body>\n" ;
    $CAS_POST_STRING .= "</html>\n" ;

    printf STDOUT "Content-Type: text/html\n\n" ;
    printf STDOUT "%s\n", $CAS_POST_STRING ;
    exit ;
    return ;
}

#$###
# CAS_LOGIN_URI ʤɤ.
# SSL  1  PORT  443 or null ʤ, https://SERVER/URI
# SSL  1  PORT ʳʤ,      https://SERVER:PORT/URI
# SSL  0  PORT  80 or null ʤ,  http://SERVER/URI
# SSL  0  PORT ʳʤ,      https://SERVER:PORT/URI
# ʸȤ֤.
sub make_cas_url
{
    local($SSL, $SERVER, $PORT, $URI) = @_ ;
    local($CAS_URI) = "" ;
    if ($SSL) {
	if (($PORT ne "443")&&($PORT ne "")) { 
	    $CAS_URI = "https://" . $SERVER . ":" . $PORT . $URI ; 
	}
	else {
	    $CAS_URI = "https://" . $SERVER . $URI ; 
	}
    }
    else {
	if (($PORT ne "80")&&($PORT ne ""))  { 
	    $CAS_URI = "http://" . $SERVER . ":" . $PORT . $URI ; 
	}
	else  {
	    $CAS_URI = "http://" . $SERVER . $URI ; 
	}
    }
    return $CAS_URI ;
}

sub sanitary 
{
    local($str) = @_ ;
    $str =~s/</&lt;/g ;
    $str =~s/>/&gt;/g ;
    $str =~s/\"/&quot;/g ;
    return $str ;
}

1;
